      program main
      implicit double precision (a-h,o-z)
      dimension pri(3 000 000)
*
*     error codes:
*
*-------------------------------------------------------------------------
*     type                  ierr   error
*
*     file handling         1      cannot open input file
*          -"-              2      cannot open output file
*          -"-              3      cannot close input file
*          -"-              4      attempt to open too many files
*          -"-              5      failed to read from input file
*          -"-              6      cannot open auxiliary input file
*          -"-              7      failed to read from point scratch file
*          -"-              8      failed to read from segment scratch file
*          -"-              9      failed to read from boundary scratch file
*
*     memory handling       11     primary memory too small
*          -"-              12     maximum number of elements exceeded
*
*     command handling      101    unknown command
*          -"-              102    too few boundaries
*          -"-              103    non-positive point number
*          -"-              104    too few points to define segment
*          -"-              105    too few segments to define boundary
*          -"-              106    no points have been defined
*          -"-              107    too few segments have been defined
*          -"-              108    no boundary has been defined
*          -"-              109    duplicate segment name
*          -"-              110    duplicate boundary name
*          -"-              111    a boundary has not been defined
*          -"-              112    a segment has not been defined
*          -"-              113    segments do not form an unbroken chain
*          -"-              114    no mehsize has been given
*          -"-              115    negative mehsize has been given
*          -"-              116    command mesh given before mesh generation
*
*     mesh generation       9000   mesh tangled, bug!!
*-------------------------------------------------------------------------
*      open(unit=6,file='output',status='unknown')
      isize=3 000 000
      call mesher(pri,isize,ierr)
*
      stop
      end
