#include <X11/Xos.h>
#include <X11/IntrinsicP.h>
#include <X11/ShellP.h>
#include <X11/Shell.h>
#include <Xfwf/FileSel.h>

static void 
Ok(widget, event, params, num_params)
Widget widget;
XEvent *event;
String *params;
Cardinal *num_params;
{
    Widget dialog = XtParent(widget);

    ColorTheButton(widget, (XtPointer) widget, (XtPointer) NULL);
}


void OkCallbackHandler(w,client_data,ret)
     Widget w;
     caddr_t client_data;
     XfwfFileSelectorOkButtonReturnStruct *ret;
{
  Widget popup;
  String path,file;
/*
  fullName = strcat(strdup(ret->path),strdup(ret->file));
  length = strlen(fullName);
  currentDirectory = strdup(ret->path);
  getresult_(fullName,&length,coord,u,p,vort,t,&re,&pr,&nnode);
  GetScalarToPlot();
  (void) sprintf(infotext, "Re = %.0f, Pr = %.2f", re, pr);
  newview_(&xe,&ye,&ze); 
 */ 
  popup = XtParent( (Widget) w);
  XtDestroyWidget(popup);

} /* End OkCallbackHandler */


void CancelCallbackHandler(w,client_data,call_data)
     Widget w;
     caddr_t client_data;
     caddr_t call_data;
{
  Widget popup;

  popup = XtParent( (Widget) w);
  XtDestroyWidget(popup);

} /* End CancelCallbackHandler */


void SelectionChangeCallbackHandler(w,client_data,ret)
     Widget w;
     caddr_t client_data;
     XfwfFileSelectorSelectionChangeReturnStruct *ret;
{

}


static void
GetNewFile(w, client_data, call_data)
     Widget w;
     XtPointer client_data, call_data;
{
  Widget top,popup,fs;
  XtAppContext app_context;
  Arg args[3];
  int n;

  top = w;

  popup = XtCreatePopupShell("PopupShell",transientShellWidgetClass,
			     top,NULL,0);

  n = 0;
	XtSetArg(args[n], XtNcurrentDirectory, currentDirectory); n++;

	fs = XtCreateManagedWidget("HFS",xfwfFileSelectorWidgetClass,
				   popup,args,n);

	XtAddCallback(fs,XtNokButtonCallback,
		(XtCallbackProc)OkCallbackHandler,NULL);
	XtAddCallback(fs,XtNcancelButtonCallback,
		(XtCallbackProc)CancelCallbackHandler,NULL);
	XtAddCallback(fs,XtNselectionChangeCallback,
		(XtCallbackProc)SelectionChangeCallbackHandler,NULL);

	XtRealizeWidget(popup);
	XtPopup(popup,XtGrabExclusive);		

}

